動機

居然用自己的dp過了!!

Problem

A wiggle sequence is a sequence where the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with one element and a sequence with two non-equal elements are trivially wiggle sequences.

  • For example, [1, 7, 4, 9, 2, 5] is a wiggle sequence because the differences (6, -3, 5, -7, 3) alternate between positive and negative.
  • In contrast, [1, 4, 7, 2, 5] and [1, 7, 4, 5, 5] are not wiggle sequences. The first is not because its first two differences are positive, and the second is not because its last difference is zero.

A subsequence is obtained by deleting some elements (possibly zero) from the original sequence, leaving the remaining elements in their original order.

Given an integer array nums, return the length of the longest wiggle subsequence of nums.

 

Example 1:

Input: nums = [1,7,4,9,2,5]Output: 6Explanation: The entire sequence is a wiggle sequence with differences (6, -3, 5, -7, 3).

Example 2:

Input: nums = [1,17,5,10,13,15,10,5,16,8]Output: 7Explanation: There are several subsequences that achieve this length.One is [1, 17, 10, 13, 10, 16, 8] with differences (16, -7, 3, -3, 6, -8).

Example 3:

Input: nums = [1,2,3,4,5,6,7,8,9]Output: 2

 

Constraints:

  • 1 <= nums.length <= 1000
  • 0 <= nums[i] <= 1000

 

Follow up: Could you solve this in O(n) time?

Sol

用mis的思路,不過這裡多要看有沒有wiggle

Wiggle可以是上下或是下上,這裡統一成上下,之後就是根據dp的奇偶性與數字大小做dp

class Solution:
    def wiggleMaxLength(self, nums: List[int]) -> int:
        dp = 1
        if len(nums) == 1:
            return 1
        
        inc = True
        for i in range(1,len(nums)):
            if nums[i-1] != nums[i]:
                inc = (nums[i-1] < nums[i])
                break
        if not inc:
            nums = [-x for x in nums]
        for i in range(1,len(nums)):
            if nums[i-1] < nums[i]:
                if dp % 2 == 1:
                    dp += 1
            elif nums[i-1] > nums[i]:
                if dp % 2 == 0:
                    dp += 1
            #print(i,dp)
        return dp

原本的解法是把上下都用成dp,在up或是down時以i為終點的最長長度

public class Solution {
    public int wiggleMaxLength(int[] nums) {
        if (nums.length < 2)
            return nums.length;
        int[] up = new int[nums.length];
        int[] down = new int[nums.length];
        up[0] = down[0] = 1;
        for (int i = 1; i < nums.length; i++) {
            if (nums[i] > nums[i - 1]) {
                up[i] = down[i - 1] + 1;
                down[i] = down[i - 1];
            } else if (nums[i] < nums[i - 1]) {
                down[i] = up[i - 1] + 1;
                up[i] = up[i - 1];
            } else {
                down[i] = down[i - 1];
                up[i] = up[i - 1];
            }
        }
        return Math.max(down[nums.length - 1], up[nums.length - 1]);
    }
}